<?PHP // $Id: index.php,v 1.1 2003/09/12 00:09:27 moodler Exp $

/// This page lists all the instances of appointment in a particular course

    require_once("../../config.php");
    require_once("lib.php");

    require_variable($id);   // course

    if (! $course = get_record("course", "id", $id)) {
        error("Course ID is incorrect");
    }

    require_login($course->id);

    add_to_log($course->id, "appointment", "view all", "index.php?id=$course->id", "");


/// Get all required strings

    $strappointments = get_string("modulenameplural", "appointment");
    $strappointment  = get_string("modulename", "appointment");


/// Print the header

    if ($course->category) {
        $navigation = "<A HREF=\"../../course/view.php?id=$course->id\">$course->shortname</A> ->";
    }

    print_header("$course->shortname: $strappointments", "$course->fullname", "$navigation $strappointments");

/// Get all the appropriate data

    if (! $appointments = get_all_instances_in_course("appointment", $course)) {
        notice("There are no appointments", "../../course/view.php?id=$course->id");
        die;
    }

/// Print the list of instances (your module will probably extend this)

    $timenow = time();
    $strname  = get_string("name");
    $strweek  = get_string("week");
    $strtopic  = get_string("topic");

    if ($course->format == "weeks") {
        $table->head  = array ($strweek, $strname);
        $table->align = array ("CENTER", "LEFT");
    } else if ($course->format == "topics") {
        $table->head  = array ($strtopic, $strname);
        $table->align = array ("CENTER", "LEFT", "LEFT", "LEFT");
    } else {
        $table->head  = array ($strname);
        $table->align = array ("LEFT", "LEFT", "LEFT");
    }

    foreach ($appointments as $appointment) {
        $link = "<A HREF=\"view.php?id=$appointment->coursemodule\">$appointment->name</A>";

        if ($course->format == "weeks" or $course->format == "topics") {
            $table->data[] = array ($appointment->section, $link);
        } else {
            $table->data[] = array ($link);
        }
    }

    echo "<BR>";

    print_table($table);

/// Finish the page

    print_footer($course);

?>
