<?PHP  // $Id: lib.php,v 1.2 2004/06/09 22:35:27 gustav_delius Exp $

/// Library of functions and constants for module NEWMODULE
/// (replace NEWMODULE with the name of your module and delete this line)


//$appointment_CONSTANT = 7;     /// for example


function appointment_add_instance($appointment) {

/// Given an object containing all the necessary data, 
/// (defined by the form in mod.html) this function 
/// will create a new instance and return the id number 
/// of the new instance.                       
    global $mod;

    $appointment->timemodified = time();
    
    $appointment->timestart = make_timestamp($appointment->year, $appointment->month, $appointment->day, 
                                          $appointment->starthour, $appointment->startminute);
    $appointment->timeend = make_timestamp($appointment->year, $appointment->month, $appointment->day, 
                                          $appointment->endhour, $appointment->endminute);
                   

    if ($mod->course) {
        if (! $course = get_record("course", "id", $mod->course)) {
            error("Course is misconfigured");
        }
    }
    $appointment->section = ceil(($appointment->timestart - $course->startdate)/604800);
    if($appointment->section > $course->numsections){
        $appointment->section = 0;
    }
    $appointment->section = "$appointment->section";
    $mod->section = "$appointment->section";
    
    return insert_record("appointment", $appointment);
}


function appointment_update_instance($appointment) {
/// Given an object containing all the necessary data, 
/// (defined by the form in mod.html) this function 
/// will update an existing instance with new data.
    global $mod;
    //global $USER;
    
    //sort out the times as timestamps
    $appointment->timemodified = time();
    $appointment->id = $appointment->instance;
    $appointment->timestart = make_timestamp($appointment->year, $appointment->month, $appointment->day, $appointment->starthour, $appointment->startminute);
    $appointment->timeend = make_timestamp($appointment->year, $appointment->month, $appointment->day, $appointment->endhour, $appointment->endminute);
                                          
    //get info about the course
    if ($mod->course) {
        if (! $course = get_record("course", "id", $mod->course)) {
            error("Course is misconfigured");
        }
    }
    
    //work out which section this should be in
    $appointment->section = ceil(($appointment->timestart - $course->startdate)/604800);
    if($appointment->section > $course->numsections){
        $appointment->section = 0;
    }
    $appointment->section = "$appointment->section";
    
    //var_dump($appointment);
    if(!update_record("appointment", $appointment)){
        error("Couldn't update record");
    }
    
    //get section info
    $section = get_record("course_sections", "course", $appointment->course, "section", $appointment->section);
    
    //remove module from the current section
    if (! delete_mod_from_section($appointment->coursemodule, $mod->section)) {
       notify("Could not delete module from existing section");
    }
    
    //update course with new module location
    if(! set_field("course_modules", "section", $section->id, "id", $appointment->coursemodule)){
         notify("Could not update course module list");
    }
    
    //add module to the new section
    if (! add_mod_to_section($appointment, NULL)) {
        notify("Could not add module to new section");
    }

    rebuild_course_cache($section->course);
    
    return true;
}

function appointment_delete_instance($id) {
/// Given an ID of an instance of this module, 
/// this function will permanently delete the instance 
/// and any data that depends on it.  

    if (! $appointment = get_record("appointment", "id", "$id")) {
        return false;
    }

    $result = true;

    # Delete any dependent records here #

    if (! delete_records("appointment", "id", "$appointment->id")) {
        $result = false;
    }

    return $result;
}

function appointment_user_outline($course, $user, $mod, $appointment) {
/// Return a small object with summary information about what a 
/// user has done with a given particular instance of this module
/// Used for user activity reports.
/// $return->time = the time they did it
/// $return->info = a short text description

    return $return;
}

function appointment_user_complete($course, $user, $mod, $appointment) {
/// Print a detailed representation of what a  user has done with 
/// a given particular instance of this module, for user activity reports.

    return true;
}

function appointment_print_recent_activity($course, $isteacher, $timestart) {
/// Given a course and a time, this module should find recent activity 
/// that has occurred in appointment activities and print it out. 
/// Return true if there was output, or false is there was none.

    global $CFG;

    return false;  //  True if anything was printed, otherwise false 
}

function appointment_cron () {
/// Function to be run periodically according to the moodle cron
/// This function searches for things that need to be done, such 
/// as sending out mail, toggling flags etc ... 

    global $CFG;

    return true;
}

function appointment_grades($appointmentid) {
/// Must return an array of grades for a given instance of this module, 
/// indexed by user.  It also returns a maximum allowed grade.

    return NULL;
}


//////////////////////////////////////////////////////////////////////////////////////
/// Any other NEWMODULE functions go here.  Each of them must have a name that 
/// starts with NEWMODULE_


?>
